library BetriebsstdZaehler1;

// Delphi 5 DLL-source (BetriebsstdZaehlerx.DLL)  kpaul 08.11.2006
// Liest bei Simulations-Start Betriebsstunden aus ini-Datei
// x:\Programme\ProfiLab-Expert40\Data\BetriebsStd
// Addiert bei High an Eingang IN0 Dezimalsekunden
// Ausgangspins geben hGesamt und hHeute aus
// Bei Simulations-Stop wird hGesamt, hHeute und MeldRef (Meldung-Referenz)
// auf Festplatte geschrieben.
// Um 00:00 Uhr wird hGesamt und MeldRef auf Festplatte geschrieben und hHeute gelscht.
// im Configure-Dialog kann ein Zeitwert ([hBisMeldung]) eingegeben werden
// nach dessen Ablauf geht Meldung-Pin auf High der mit /Me-RST zurckgesetzt wird.


uses
  SysUtils,
  Windows,
  Classes,
  DateUtils,
  Dialogs,
  IniFiles,
  Math,
  Forms;

{$R *.RES}

Const  Inputs =  3;  // number of inputs
       Outputs = 3;  // number of outputs

       {INPUTS}
       IN0    = 0;   // index of input variable IN0
       FileNr = 1;   // index of input variable FileNr
       RST    = 2;   // index of input variable RST

       {OUTPUTS}
       hGesamt     = 0;
       hHeute      = 1;
       Meldung     = 2;

       {USER}
       {hGesamt     = 0;} // bei Outputs schon definiert
       {hHeute      = 1;} // bei Outputs schon definiert
       IN0_old     = 4;   // index user variable IN0_old
       RST_old     = 5;   // index user variable RST_old
       MeldRef     = 6;   // index user variable MeldRef (Stunden-Zhler fr Meldung)
       secEin_merk = 7;   // index user variable SecondOfTheDay beim Einschalten der Pumpe
       FiNr        = 8;   // index user variable Filenummer
       neuerTag    = 9;   // index user variable Sekunden des neuen Tages ber Mitternacht
       hBisMeldung = 10;  // index user variable hBisMeldung
       start       = 11;  // index user variable start

       DezSek      =  1/3600;   //Dezimalsekunde = 0.000277777

Type TDLLParams = array[0..100] of extended;   //Type of ProfiLab DLL parameters
     PDLLParams = ^TDLLParams;                 // Pointer to ProfiLab DLL parameters

function NumInputs: Byte;
begin
  result:=Inputs; //Define number of component input pins
end;

function NumOutputs: Byte;
begin
  result:=Outputs; //Define number of component output pins
end;

Function InputName(Channel: Byte): ShortString; // Return name for each component input pin
begin
   case Channel of
   IN0:    result:='IN0';       //  "IN0"    (Messeingang)
   FileNr: result:='FileNr';    //  "FileNr" (FileNr)
   RST:    result:='/Me-RST';   //  "/Me-RST" (NOT RESET) f. Meldung-Reset
   end;
end;

Function OutputName(Channel: Byte): ShortString; // Return name for each component output pin
begin
   case Channel of
   hGesamt:    result:='hGesamt';     //  "hGesamt"
   hHeute:     result:='hHeute';      //  "hHeute"
   Meldung:    result:='Meldung';     //  "Meldung"  (abgelaufene Zeit)
   end;
end;

Procedure SimStart(PInput,POutput,PUser: PDLLParams); //called when ProfiLab enters RUN mode
var i: Integer;
    FiNr: string;                                   //FileNr als String

begin
    //Vorsicht: in SimStart kann in compilierten Profilab-Programmen nicht aus ini-Datei gelesen werden!!!
   FiNr:= FloatToStr(PInput^[FileNr]);              //an Pin anstehende FileNr abfragen
   PUser^[secEin_merk]:= SecondOfTheDay(Time);      //Sekunden des Tages wenn bei START IN0 schon High ist
                                                    //Zhler auf nchste Sekunde einklinken.
   For i:=0 to Outputs do
   begin
       POutput^[i]:=0; //Set binary outputs with COUNT=0
   end;

   PUser^[start]:=0;
   PUser^[IN0_old]:=0;
   PUser^[neuerTag]:= DayOfTheWeek(Date);                       //Tag des Monats
end;

Procedure SimStop(PInput,POutput,PUser: PDLLParams); //called when ProfiLab RUN mode is terminated
var IniFile: TIniFile;
    FiNr: string;                                   //FileNr als String

begin
    //Vorsicht: Additionen knnen in compilierten Profilab-Programmen doppelt ausgefhrt werden!!!
    //am Besten keine Rechenaufgaben in SimStop.

    //Wert abspeichern:
   FiNr:= FloatToStr(PInput^[FileNr]);              //an Pin anstehende FileNr abfragen
   IniFile:=TIniFile.Create(ExtractFileDrive(Application.Exename)+'\Programme\ProfiLab-Expert40\Data\BetriebsStd'+FiNr+'.ini');
   IniFile.WriteFloat('BetriebsStd','hGesamt',SimpleRoundTo(PUser^[hGesamt],-5));
   IniFile.WriteFloat('BetriebsStd','hHeute' ,SimpleRoundTo(PUser^[hHeute] ,-5));
   IniFile.WriteFloat('BetriebsStd','MeldRef',SimpleRoundTo(PUser^[MeldRef],-5));
   IniFile.Free;

end;

Procedure Calculate(PInput,POutput,PUser: PDLLParams); //called regularly from ProfiLab
var i: Extended;
    Sekunden, Tag: Integer;
    IniFile: TIniFile;
    FiNr: string;                                   //FileNr als String
    label weiter;                                   //Deklaration der goto-Sprnge

begin
  Sekunden:= SecondOfTheDay(Time);                  //Sekunden des Tages
  Tag:=      DayOfTheWeek (Date);                   //Tag der Woche

   if PUser^[start]= 0 then begin           //einmaliger Durchlauf bei Programmstart -> Daten aus ini-Datei lesen
                        //funktioniert in einem compilierten PLE-Projekt nicht wenn dies in SimStart stehen wrde!!
     //Wert einlesen:
     FiNr:= FloatToStr(PInput^[FileNr]);                //an Pin anstehende FileNr abfragen
     IniFile:=TIniFile.Create(ExtractFileDrive(Application.Exename)+'\Programme\ProfiLab-Expert40\Data\BetriebsStd'+FiNr+'.ini');
     PUser^  [hGesamt]:=IniFile.ReadFloat('BetriebsStd','hGesamt',0);
     PUser^  [hHeute] :=IniFile.ReadFloat('BetriebsStd','hHeute',0);
     PUser^[MeldRef]  :=IniFile.ReadFloat('BetriebsStd','MeldRef',0);
     IniFile.Free;
     PUser^[start]:=1;                                  //kein Durchlauf mehr
   end;

   if PInput^[IN0]>2.5 then //check IN0 input HIGH or LOW
   begin
      if (PInput^[IN0]>2.5) and not(PUser^[IN0_old]>2.5) then //check out rising edge at IN0 input
      begin
        PUser^[secEin_merk]:= Sekunden;                 //Einschaltzeitpunkt merken
      end;
      if Sekunden <> PUser^[secEin_merk] then           //erst noch eine Runde und auf nchste Sekunde einklinken
      begin
        PUser^[hGesamt]:= PUser^[hGesamt]+DezSek;       //1 DezSek addieren
        PUser^[hHeute ]:= PUser^[hHeute ]+DezSek;       //1 DezSek addieren
        PUser^[secEin_merk]:= Sekunden;                 //gleichsetzen
      end;
   end;

   PUser^[IN0_old]:=PInput^[IN0];       //Remember IN0 status for next call

//...

   POutput^[hGesamt]:= PUser^[hGesamt] +0.000005;               //Anzeige-Ausgabe an Pin mit aufrunden
   POutput^[hHeute ]:= PUser^[hHeute ] +0.000005;               //Anzeige-Ausgabe an Pin mit aufrunden
                                        //aufrunden ntig sonst wird statt z.B. 16  15.99999 errechnet

//---------- Meldung ausgeben wenn Zhlerstand erreicht:
   i:=PUser^[hGesamt];                                                      //aktuelle Betriebsstd-Zeit
   if i-PUser^[MeldRef]>= PUser^[hBisMeldung] then POutput^[Meldung]:= 5 else POutput^[Meldung]:= 0;

//---------- MeldRef auf aktuellen Wert (i) setzen bei /RST-Eingang low:
   if PInput^[RST]<2.5 then //check RST input HIGH or LOW
   begin
      if (not (PInput^[RST]>=2.5)) and (PUser^[RST_old]>2.5) then //check out falling edge at RST input
      begin
         PUser^[MeldRef]:=i;                        //Zhler gleichsetzen
      end;
      goto weiter;                  //weiterspringen, da Reset ausgefhrt wird solange RST auf 0
   end;
   PUser^[RST_old]:=PInput^[RST];   //Remember RST status for next call
   weiter:                          //Label

//---------- Mitternacht, Tag abschliessen:
   if Tag <> PUser^[neuerTag] then                          //neuer Tag angebrochen
   begin
     PUser^[hHeute]:=0;
     PUser^[neuerTag]:= Tag;                                //merken
     PUser^[IN0_old]:=0;    //wenn ber Mitternacht eingeschaltet, Zhlerstart wie bei rising edge

    //Wert abspeichern wie bei DLL-Stop:
   FiNr:= FloatToStr(PInput^[FileNr]);              //an Pin anstehende FileNr abfragen
   IniFile:=TIniFile.Create(ExtractFileDrive(Application.Exename)+'\Programme\ProfiLab-Expert40\Data\BetriebsStd'+FiNr+'.ini');
   IniFile.WriteFloat('BetriebsStd','hGesamt',SimpleRoundTo(PUser^[hGesamt],-5));
   IniFile.WriteFloat('BetriebsStd','hHeute' ,SimpleRoundTo(PUser^[hHeute] ,-5));
   IniFile.WriteFloat('BetriebsStd','MeldRef',SimpleRoundTo(PUser^[MeldRef],-5));
   IniFile.Free;
   end;
//----------:

end;

Procedure Configure(PUser: PDLLParams);
begin
  PUser^[hBisMeldung]:= StrToFloat(InputBox('Input Box', 'Std. bis zur Meldung', FloatToStr(PUser^[hBisMeldung])));

  ShowMessage ('Datei=  ' + ExtractFilePath(Application.Exename) + 'Data\BetriebsStd'+'[FileNr]'+'.ini');
end;

//export methods for ProfiLab
exports SimStart,
        SimStop,
        NumInputs,
        NumOutputs,
        Calculate,
        InputName,
        OutputName,
        Configure;

begin
end.

